// Uses Declarative syntax to run commands inside a container.
pipeline {
    agent {
        kubernetes {
            // Rather than inline YAML, in a multibranch Pipeline you could use: yamlFile 'jenkins-pod.yaml'
            // Or, to avoid YAML:
            // containerTemplate {
            //     name 'shell'
            //     image 'ubuntu'
            //     command 'sleep'
            //     args 'infinity'
            // }
            yaml '''
apiVersion: v1
kind: Pod
metadata:
  name: dind-pod
spec:
  containers:
  - name: shell
    image: docker:dind
    command:
      - "sleep"
      - "infinity"
    securityContext:
      privileged: true
    volumeMounts:
    - name: docker-socket
      mountPath: /var/run/docker.sock
  volumes:
  - name: docker-socket
    hostPath:
      path: /var/run/docker.sock


'''
            // Can also wrap individual steps:
            // container('shell') {
            //     sh 'hostname'
            // }
            defaultContainer 'shell'
        }
    }
    stages {
        stage('Main') {
            steps {
                sh 'hostname'
                sh 'whoami'
                sh 'ls'
                sh 'pwd'
                sh 'docker ps'
                sh 'docker build -t dexterquazi/test .'
                sh 'docker login -u dexterquazi -p "##Love##1"'
                sh 'docker push dexterquazi/test'
                sh 'docker rmi dexterquazi/test'
            }
        }
    }
}
